#ifndef _XARXA_
#define _XARXA_

#include "Arbre.hpp"
#include "Servidor.hpp"

class Xarxa{

private:

  Arbre<int> estructura;
  vector<Servidor> servidors;

public:

  Xarxa(int N, int M);
  /* Pre: N>0, M>0 */
  /* Post: el resultat es una xarxa buida amb capacitat per a N servidors
     cadascu dels quals pot tenir fins a M pelis */

  void llegir_xarxa();
  /* Pre: al cin hi ha l'estructura de la xarxa de servidors */
  /* Post: al p.i. hi ha l'estructura de la xarxa de servidors */

  void llegir_dades_servidors();
  /* Pre: al cin hi ha els amples de banda de tants servidors com la mida del
     p.i. i els identificadors de les pelis que contenen */
  /* Post: cada servidor del p.i. te el seu ample de banda i l'informacio
     sobre les seves pelis, pres del cin */

  void processar_peticio(int id_film, int size_film);
  /* Pre: id_film es un identificador valid de pelicula, size_film>0;
     una peli amb aquestes dades es descarregable al p.i. */
  /* Post: s'ha escrit pel cout els servidors que s'utilitzan per descarregar
     la pelicula id_film amb mida size_film, ordenats creixentment per id */

private:

  static void llegir_arbre(Arbre<int>& a, int marca);
  /* Pre: al cin hi ha l'estructura d'un arbre d'enters en preordre */
  /* Post: a es un arbre llegit del cin */

  // aqui poseu les operacions que faltin

};

#endif

